/*  Vaucanson, a generic library for finite state machines.
Copyright (C) 2001, 2002, 2004, 2005 The Vaucanson Group.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

The complete GNU General Public Licence Notice can be found as the
`NOTICE' file in the root directory.

The Vaucanson Group consists of people listed in the `AUTHORS' file.
*/
#include <cassert>
#include <vaucanson/design_pattern/design_pattern.hh>
#define CREATE_SEMIRING(m)
#include <vaucanson/algebra/implementation/free_monoid/predefs.hh>
#include <vaucanson/algebra/implementation/free_monoid_product/freemonoid_product_pair_str.hh>

#define TEST_STATIC_ARGS						    \
	vcsn::algebra::FreeMonoidProduct<vcsn::algebra::char_letter::Words, \
			  vcsn::algebra::char_letter::Words>,		    \
	std::pair<std::string, std::string>

#include <check/tester.hh>
#include <free_monoid_product_test.hh>

  int main(int argc, char **argv)
  {
  using namespace vcsn;
  tests::verbose_level verbose = tests::low;
  srand(time(0));

  if (argc > 1)
    {
      if (argv[1] == std::string("--no-verbose"))
	verbose = tests::none;
      else if (argv[1] == std::string ("--high-verbose"))
	verbose = tests::high;
      else
	verbose = tests::low;
    };
    tests::Tester t(verbose);
    if (free_monoid_product_test<TEST_STATIC_ARGS>(t))
      return EXIT_SUCCESS;
    else
      return EXIT_FAILURE;
  }

